package cz.mendelu.dnaAnalyser.analyse.g4hunter.quadruplex;

import cz.mendelu.dnaAnalyser.overlay.LocalisedOverlay;
import cz.mendelu.dnaAnalyser.utils.analyse.service.AbstractDataSessionService;
import cz.mendelu.dnaAnalyser.utils.analyse.service.heatmap.HeatmapService;
import org.apache.ibatis.session.Configuration;
import org.springframework.stereotype.Service;

import java.sql.SQLException;
import java.sql.Statement;

@Service
public class QuadruplexDataSessionService extends AbstractDataSessionService implements HeatmapService, LocalisedOverlay {

    @Override
    protected void onCreateTables(Statement statement) throws SQLException {
        statement.execute(QuadruplexMapper.TABLE);
        statement.execute(AggregateQuadruplexMapper.TABLE);
    }

    @Override
    protected void onConfiguration(Configuration configuration) {
        configuration.getTypeAliasRegistry().registerAlias(Quadruplex.class);
        configuration.addMapper(QuadruplexMapper.class);

        configuration.getTypeAliasRegistry().registerAlias(AggregateQuadruplex.class);
        configuration.addMapper(AggregateQuadruplexMapper.class);
    }
}
