package cz.mendelu.dnaAnalyser.analyse.rloopr;

import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.UUID;

import cz.mendelu.dnaAnalyser.utils.analyse.data.Localised;
import lombok.AllArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class RlooprResult implements Localised {
    protected int position;
    protected int length;
    protected String riz;
    protected double rizGRichness;
    protected String linker;
    protected String rez;
    protected double rloopGRichness;
    protected long g3cnt;
    protected long g4cnt;
    protected long gNcnt; // N clusters, where N > 4
    protected Long id;
    protected String model;
    protected Character strand;

    @Override
    public int getMiddle() {
        return this.position + (length/2);
    }

}
