package cz.mendelu.dnaAnalyser.analyse.zdna;

import cz.mendelu.dnaAnalyser.sequence.Sequence;
import cz.mendelu.dnaAnalyser.user.User;
import cz.mendelu.dnaAnalyser.utils.analyse.model.Analyse;
import cz.mendelu.dnaAnalyser.utils.model.Identifiable;
import lombok.*;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;
import java.util.Set;
import java.util.UUID;

@Data
@Entity
@ToString(callSuper = true)
@NoArgsConstructor(access = AccessLevel.PROTECTED)
@EqualsAndHashCode(callSuper = true)
@Table(name = "zdna_analyses")
public class Zdna extends Analyse implements Identifiable {

    @Builder
    private Zdna(UUID id, Date created, Sequence sequence, User owner, Set<String> tags, Date finished, Long resultCount, Integer minSequenceSize, Float threshold, Float score_gc, Float score_gtac, Float score_at, Float score_oth) {
        super((id != null) ? id : UUID.randomUUID(), created, sequence, owner, tags, finished, sequence.getName(), resultCount);

        this.minSequenceSize = minSequenceSize;
        this.threshold = threshold;
        this.score_gc = score_gc;
        this.score_gtac = score_gtac;
        this.score_at = score_at;
        this.score_oth = score_oth;
    }

    @Column(name = "window_size")
    private Integer minSequenceSize = 10;

    private Float threshold = (float) 7.5;

    private Float score_gc = (float) 1;

    private Float score_gtac = (float) 0.5;

    private Float score_at = (float) 0.25;

    private Float score_oth = (float) 0;
}
