package cz.mendelu.dnaAnalyser.analyse.palindrome.detector

import cz.mendelu.dnaAnalyser.sequence.NucleicBuffer
import cz.mendelu.dnaAnalyser.sequence.Sequence
import cz.mendelu.dnaAnalyser.sequence.data.SequenceData

class SequenceTestSupport extends GroovyTestCase {

    static stringAsSequence() {
        String.metaClass.define {
            oldAsType = String.metaClass.getMetaMethod("asType", [Class] as Class[])
            asType = { Class c ->
                if (c == SequenceData) {
                    SequenceData.wrap(new Sequence(
                            id: UUID.randomUUID(),
                            circular: false),
                            delegate.bytes)
                } else if (c == NucleicBuffer) {
                    SequenceData.wrap(new Sequence(
                            id: UUID.randomUUID(),
                            circular: false),
                            delegate.bytes)
                            .iterator()
                } else {
                    oldAsType.invoke(delegate, c)
                }
            }
        }
    }

    void testConvertSequenceData() {
        def s = "ACTG" as SequenceData
        assert s instanceof SequenceData
    }

    void testConvertNucleicBuffer() {
        def s = "ACTG" as NucleicBuffer
        assert s instanceof NucleicBuffer
    }
}
