package cz.mendelu.dnaAnalyser.batch

import cz.mendelu.dnaAnalyser.utils.api.ApiRestTemplate
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import org.springframework.http.HttpStatus
import org.springframework.test.context.ActiveProfiles
import spock.lang.Ignore
import spock.lang.Specification

import static org.springframework.boot.test.context.SpringBootTest.WebEnvironment.RANDOM_PORT

@SpringBootTest(webEnvironment = RANDOM_PORT)
@ActiveProfiles("test")
class BatchControllerTest extends Specification {

    @Autowired
    ApiRestTemplate api

    def setup() {
        api.authentication('user@mendelu.cz', 'user')
    }

    @Ignore
    def "GET:/api/batch Get page with batches."(){
        when:
        def response = api.get("/api/batch")

        then:
        response.status == HttpStatus.OK.value()
    }

    @Ignore
    def "GET:/api/batch/{entityClass} Get page with batches by entity class."(){
        setup:
        def entityClass = "cz.mendelu.bioinformatics.module.sequence.model.Sequence"

        when:
        def response = api.get("/api/batch/${entityClass}")

        then:
        response.status == HttpStatus.OK.value()
    }

    @Ignore
    def "GET:/api/batch/{entityClass}/{entityId} Get batch by entity class and entity id."(){
        setup:
        def entityClass = "cz.mendelu.bioinformatics.module.sequence.model.Sequence"
        def entityId = UUID.fromString("090e5461-6dd3-44ff-8e01-7b84435857fa")

        when:
        def response = api.get("/api/batch/${entityClass}/${entityId}")

        then:
        response.status == HttpStatus.OK.value()
    }

    @Ignore
    def "DELETE:/api/batch/{entityClass}/{entityId} Delete batch by entity class and entity id."(){
        setup:
        def entityClass = "cz.mendelu.bioinformatics.module.sequence.model.Sequence"
        def entityId = UUID.fromString("090e5461-6dd3-44ff-8e01-7b84435857fa")

        when:
        def response = api.delete("/api/batch/${entityClass}/${entityId}")

        then:
        response.status == HttpStatus.OK.value()
    }
}