package cz.mendelu.dnaAnalyser.email.service

import cz.mendelu.dnaAnalyser.email.model.Email
import spock.lang.Ignore
import spock.lang.Specification
import spock.lang.Subject

class EmailServiceTest extends Specification {

    @Subject EmailService emailService

    def setup() {
        emailService = new EmailService()
        emailService.smtp = 'localhost'
        emailService.port = 25
        emailService.from = 'dev-test@bioinformatics.cz'
    }

    @Ignore
    def "SendEmail"() {
        setup:
        def email = new Email("jan.kolomaznik@gmail.com")
        email.setSubject("Email service test")
        email.getContentBuilder()
                .append("Test message")
        def mineMessage

        when:
        try {
            mineMessage = emailService.sendEmail(email)
        } catch (UnsupportedOperationException e) {
            // TODO Fixme email not send throw localhost!
        }
        then:
        mineMessage != null
    }
}
