package cz.mendelu.dnaAnalyser.utils.analyse.service.heatmap;

import cz.mendelu.dnaAnalyser.utils.analyse.data.DataMapper;
import cz.mendelu.dnaAnalyser.utils.analyse.model.Analyse;
import cz.mendelu.dnaAnalyser.utils.model.Identifiable;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.defaults.DefaultSqlSession;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class TestHeatmapService implements HeatmapService {

    private Map<Class, DataMapper> dataMappers;

    public TestHeatmapService(Class mapperClass, DataMapper dataMappers) {
        this.dataMappers = new HashMap<>();
        this.dataMappers.put(mapperClass, dataMappers);
    }

    @Override
    public <A extends Identifiable> SqlSession openDataSession(A analyse) {
        return new DefaultSqlSession(null, null) {
            @Override
            public <T> T getMapper(Class<T> type) {
                return (T) dataMappers.get(type);
            }

            @Override
            public void close() {
            }
        };
    }

    @Override
    public <A extends Identifiable> Connection openConnection(A analyse) throws SQLException {
        throw new UnsupportedOperationException("Not implemented yet.");
    }

    @Override
    public Connection openConnection(UUID uuid) throws SQLException {
        throw new UnsupportedOperationException("Not implemented yet.");
    }
}